diff --git a/yumcommands.py b/yumcommands.py
index 4dcbea7..b610f3a 100644
--- a/yumcommands.py
+++ b/yumcommands.py
@@ -673,164 +1650,474 @@ class CheckUpdateCommand(YumCommand):
                 for obtup in sorted(ypl.obsoletesTuples,
                                     key=operator.itemgetter(0)):
                     base.updatesObsoletesList(obtup, 'obsoletes',
-                                              columns=columns)
+                                              columns=columns, repoid=repoid)
                 result = 100
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
-        else:
-            return result, []
+
+            # Add check_running_kernel call, if updateinfo is available.
+            if (base.conf.autocheck_running_kernel and
+                updateinfo._repos_downloaded(base.repos.listEnabled())):
+                def _msg(x):
+                    base.verbose_logger.info("%s", x)
+                updateinfo._check_running_kernel(base, base.upinfo, _msg)
+        return result, []
+
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        return 'read-only:future'
+
 
 class SearchCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    search command.
+    """
+
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['search']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return "SOME_STRING"
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Search package details for the given string")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can
+        run; namely that this command is called with appropriate arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkItemArg(base, basecmd, extcmds)
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         base.logger.debug(_("Searching Packages: "))
-        try:
-            return base.search(extcmds)
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        updateinfo.exclude_updates(base)
+        return base.search(extcmds)
 
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
         return False
 
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        return 'read-only:present'
+
+
 class UpgradeCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    upgrade command.
+    """
+
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['upgrade', 'upgrade-to']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return 'PACKAGE...'
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Update packages taking obsoletes into account")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can
+         run.  These include that the program is being run by the root
+         user, and that there are enabled repositories with gpg.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkRootUID(base)
         checkGPGKey(base)
         checkEnabledRepo(base, extcmds)
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         base.conf.obsoletes = 1
         self.doneCommand(base, _("Setting up Upgrade Process"))
-        try:
-            return base.updatePkgs(extcmds, update_to=(basecmd == 'upgrade-to'))
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        ret = base.updatePkgs(extcmds, update_to=(basecmd == 'upgrade-to'))
+        updateinfo.remove_txmbrs(base)
+        return ret
 
 class LocalInstallCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    localinstall command.
+    """
+
     def __init__(self):
         YumCommand.__init__(self)
         self.hidden = True
 
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['localinstall', 'localupdate']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return "FILE"
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Install a local RPM")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can
+        run.  These include that there are enabled repositories with
+        gpg keys, and that this command is called with appropriate
+        arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkRootUID(base)
         checkGPGKey(base)
         checkPackageArg(base, basecmd, extcmds)
         
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is:
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         self.doneCommand(base, _("Setting up Local Package Process"))
 
         updateonly = basecmd == 'localupdate'
-        try:
-            return base.localInstall(filelist=extcmds, updateonly=updateonly)
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        return base.localInstall(filelist=extcmds, updateonly=updateonly)
 
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
         return False
 
 class ResolveDepCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    resolvedep command.
+    """
+
+    def __init__(self):
+        YumCommand.__init__(self)
+        self.hidden = True
+
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['resolvedep']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return "DEPENDENCY"
 
     def getSummary(self):
-        return _("Determine which package provides the given dependency")
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
+        return "repoquery --pkgnarrow=all --whatprovides --qf '%{envra} %{ui_from_repo}'"
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         base.logger.debug(_("Searching Packages for Dependency:"))
-        try:
-            return base.resolveDepCli(extcmds)
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        updateinfo.exclude_updates(base)
+        return base.resolveDepCli(extcmds)
+
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        return 'read-only:past'
+
 
 class ShellCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    shell command.
+    """
+
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['shell']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return "[FILENAME]"
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("Run an interactive yum shell")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can
+        run; namely that this command is called with appropriate arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkShellArg(base, basecmd, extcmds)
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         self.doneCommand(base, _('Setting up Yum Shell'))
-        try:
-            return base.doShell()
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        return base.doShell()
 
     def needTs(self, base, basecmd, extcmds):
+        """Return whether a transaction set must be set up before this
+        command can run.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: True if a transaction set is needed, False otherwise
+        """
         return False
 
 
 class DepListCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    deplist command.
+    """
+
     def getNames(self):
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
         return ['deplist']
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return 'PACKAGE...'
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _("List a package's dependencies")
 
     def doCheck(self, base, basecmd, extcmds):
+        """Verify that conditions are met so that this command can
+        run; namely that this command is called with appropriate
+        arguments.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        """
         checkPackageArg(base, basecmd, extcmds)
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         self.doneCommand(base, _("Finding dependencies: "))
-        try:
-            return base.deplist(extcmds)
-        except yum.Errors.YumBaseError, e:
-            return 1, [str(e)]
+        updateinfo.exclude_updates(base)
+        return base.deplist(extcmds)
+
+    def cacheRequirement(self, base, basecmd, extcmds):
+        """Return the cache requirements for the remote repos.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: a list of arguments passed to *basecmd*
+        :return: Type of requirement: read-only:past, read-only:present, read-only:future, write
+        """
+        return 'read-only:past' # read-only ?
 
 
 class RepoListCommand(YumCommand):
+    """A class containing methods needed by the cli to execute the
+    repolist command.
+    """
     
     def getNames(self):
-        return ('repolist',)
+        """Return a list containing the names of this command.  This
+        command can be called from the command line by using any of these names.
+
+        :return: a list containing the names of this command
+        """
+        return ('repolist', 'repoinfo')
 
     def getUsage(self):
+        """Return a usage string for this command.
+
+        :return: a usage string for this command
+        """
         return '[all|enabled|disabled]'
 
     def getSummary(self):
+        """Return a one line summary of this command.
+
+        :return: a one line summary of this command
+        """
         return _('Display the configured software repositories')
 
     def doCommand(self, base, basecmd, extcmds):
+        """Execute this command.
+
+        :param base: a :class:`yum.Yumbase` object
+        :param basecmd: the name of the command
+        :param extcmds: the command line arguments passed to *basecmd*
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         def _repo_size(repo):
             ret = 0
             for pkg in repo.sack.returnPackages():
@@ -838,12 +2125,9 @@ class RepoListCommand(YumCommand):
             return base.format_number(ret)
 
         def _repo_match(repo, patterns):
-            rid = repo.id.lower()
-            rnm = repo.name.lower()
             for pat in patterns:
-                if fnmatch.fnmatch(rid, pat):
-                    return True
-                if fnmatch.fnmatch(rnm, pat):
+                if repo in base.repos.findRepos(pat, name_match=True,
+                                                ignore_case=True):
                     return True
             return False
 
@@ -857,7 +2141,10 @@ class RepoListCommand(YumCommand):
             arg = 'enabled'
         extcmds = map(lambda x: x.lower(), extcmds)
 
-        verbose = base.verbose_logger.isEnabledFor(logginglevels.DEBUG_3)
+        if basecmd == 'repoinfo':
+            verbose = True
+        else:
+            verbose = base.verbose_logger.isEnabledFor(logginglevels.DEBUG_3)
         if arg != 'disabled' or extcmds:
             try:
                 # Setup so len(repo.sack) is correct
@@ -866,6 +2153,13 @@ class RepoListCommand(YumCommand):
             except yum.Errors.RepoError:
                 if verbose:
                     raise
+                #  populate them by hand, so one failure doesn't kill everything
+                # after it.
+                for repo in base.repos.listEnabled():
+                    try:
+                        base.repos.populateSack(repo.id)
+                    except yum.Errors.RepoError:
+                        pass
 
         repos = base.repos.repos.values()
         repos.sort()
@@ -924,111 +2218,113 @@ class RepoListCommand(YumCommand):
                 ui_enabled = dhibeg + _('disabled') + hiend
                 ui_endis_wid = utf8_width(_('disabled'))
 
-            if True: # Here to make patch smaller, TODO: rm
-                if not verbose:
-                    rid = str(repo)
-                    if enabled and repo.metalink:
-                        mdts = repo.metalink_data.repomd.timestamp
-                        if mdts > repo.repoXML.timestamp:
-                            rid = '*' + rid
-                    cols.append((rid, repo.name,
-                                 (ui_enabled, ui_endis_wid), ui_num))
+            if not verbose:
+                rid = repo.ui_id # can't use str()
+                if repo.metadata_expire >= 0:
+                    if os.path.exists(repo.metadata_cookie):
+                        last = os.stat(repo.metadata_cookie).st_mtime
+                        if last + repo.metadata_expire < time.time():
+                            rid = '!' + rid
+                if enabled and repo.metalink:
+                    mdts = repo.metalink_data.repomd.timestamp
+                    if mdts > repo.repoXML.timestamp:
+                        rid = '*' + rid
+                cols.append((rid, repo.name,
+                             (ui_enabled, ui_endis_wid), ui_num))
+            else:
+                if enabled:
+                    md = repo.repoXML
                 else:
+                    md = None
+                out = [base.fmtKeyValFill(_("Repo-id      : "), repo.ui_id),
+                       base.fmtKeyValFill(_("Repo-name    : "), repo.name)]
+
+                if force_show or extcmds:
+                    out += [base.fmtKeyValFill(_("Repo-status  : "),
+                                               ui_enabled)]
+                if md and md.revision is not None:
+                    out += [base.fmtKeyValFill(_("Repo-revision: "),
+                                               md.revision)]
+                if md and md.tags['content']:
+                    tags = md.tags['content']
+                    out += [base.fmtKeyValFill(_("Repo-tags    : "),
+                                               ", ".join(sorted(tags)))]
+
+                if md and md.tags['distro']:
+                    for distro in sorted(md.tags['distro']):
+                        tags = md.tags['distro'][distro]
+                        out += [base.fmtKeyValFill(_("Repo-distro-tags: "),
+                                                   "[%s]: %s" % (distro,
+                                                   ", ".join(sorted(tags))))]
+
+                if md:
+                    out += [base.fmtKeyValFill(_("Repo-updated : "),
+                                               time.ctime(md.timestamp)),
+                            base.fmtKeyValFill(_("Repo-pkgs    : "),ui_num),
+                            base.fmtKeyValFill(_("Repo-size    : "),ui_size)]
+
+                if hasattr(repo, '_orig_baseurl'):
+                    baseurls = repo._orig_baseurl
+                else:
+                    baseurls = repo.baseurl
+                if baseurls:
+                    out += [base.fmtKeyValFill(_("Repo-baseurl : "),
+                                               ", ".join(baseurls))]
+
+                if enabled:
+                    # This needs to be here due to the mirrorlists are
+                    # metalinks hack.
+                    repo.urls
+                if repo.metalink:
+                    out += [base.fmtKeyValFill(_("Repo-metalink: "),
+                                               repo.metalink)]
                     if enabled:
-                        md = repo.repoXML
-                    else:
-                        md = None
-                    out = [base.fmtKeyValFill(_("Repo-id      : "), repo),
-                           base.fmtKeyValFill(_("Repo-name    : "), repo.name)]
-
-                    if force_show or extcmds:
-                        out += [base.fmtKeyValFill(_("Repo-status  : "),
-                                                   ui_enabled)]
-                    if md and md.revision is not None:
-                        out += [base.fmtKeyValFill(_("Repo-revision: "),
-                                                   md.revision)]
-                    if md and md.tags['content']:
-                        tags = md.tags['content']
-                        out += [base.fmtKeyValFill(_("Repo-tags    : "),
-                                                   ", ".join(sorted(tags)))]
-
-                    if md and md.tags['distro']:
-                        for distro in sorted(md.tags['distro']):
-                            tags = md.tags['distro'][distro]
-                            out += [base.fmtKeyValFill(_("Repo-distro-tags: "),
-                                                       "[%s]: %s" % (distro,
-                                                       ", ".join(sorted(tags))))]
-
-                    if md:
-                        out += [base.fmtKeyValFill(_("Repo-updated : "),
-                                                   time.ctime(md.timestamp)),
-                                base.fmtKeyValFill(_("Repo-pkgs    : "),ui_num),
-                                base.fmtKeyValFill(_("Repo-size    : "),ui_size)]
-
-                    if hasattr(repo, '_orig_baseurl'):
-                        baseurls = repo._orig_baseurl
-                    else:
-                        baseurls = repo.baseurl
-                    if baseurls:
-                        out += [base.fmtKeyValFill(_("Repo-baseurl : "),
-                                                   ", ".join(baseurls))]
-
-                    if enabled:
-                        #  This needs to be here due to the mirrorlists are
-                        # metalinks hack.
-                        repo.urls
-                    if repo.metalink:
-                        out += [base.fmtKeyValFill(_("Repo-metalink: "),
-                                                   repo.metalink)]
-                        if enabled:
-                            ts = repo.metalink_data.repomd.timestamp
-                            out += [base.fmtKeyValFill(_("  Updated    : "),
-                                                       time.ctime(ts))]
-                    elif repo.mirrorlist:
-                        out += [base.fmtKeyValFill(_("Repo-mirrors : "),
-                                                   repo.mirrorlist)]
-                    if enabled and repo.urls and not baseurls:
-                        url = repo.urls[0]
-                        if len(repo.urls) > 1:
-                            url += ' (%d more)' % (len(repo.urls) - 1)
-                        out += [base.fmtKeyValFill(_("Repo-baseurl : "),
-                                                   url)]
-
-                    if not os.path.exists(repo.metadata_cookie):
-                        last = _("Unknown")
-                    else:
-                        last = os.stat(repo.metadata_cookie).st_mtime
-                        last = time.ctime(last)
+                        ts = repo.metalink_data.repomd.timestamp
+                        out += [base.fmtKeyValFill(_("  Updated    : "),
+                                                   time.ctime(ts))]
+                elif repo.mirrorlist:
+                    out += [base.fmtKeyValFill(_("Repo-mirrors : "),
+                                               repo.mirrorlist)]
+                if enabled and repo.urls and not baseurls:
+                    url = repo.urls[0]
+                    if len(repo.urls) > 1:
+                        url += ' (%d more)' % (len(repo.urls) - 1)
+                    out += [base.fmtKeyValFill(_("Repo-baseurl : "), url)]
+
+                if not os.path.exists(repo.metadata_cookie):
+                    last = _("Unknown")
+                else:
+                    last = os.stat(repo.metadata_cookie).st_mtime
+                    last = time.ctime(last)
 
-                    if repo.metadata_expire <= -1:
-                        num = _("Never (last: %s)") % last
-                    elif not repo.metadata_expire:
-                        num = _("Instant (last: %s)") % last
-                    else:
-                        num = _num2ui_num(repo.metadata_expire)
-                        num = _("%s second(s) (last: %s)") % (num, last)
+                if repo.metadata_expire <= -1:
+                    num = _("Never (last: %s)") % last
+                elif not repo.metadata_expire:
+                    num = _("Instant (last: %s)") % last
+                else:
+                    num = _num2ui_num(repo.metadata_expire)
+                    num = _("%s second(s) (last: %s)") % (num, last)
 
-                    out += [base.fmtKeyValFill(_("Repo-expire  : "), num)]
+                out += [base.fmtKeyValFill(_("Repo-expire  : "), num)]
 
-                    if repo.exclude:
-                        out += [base.fmtKeyValFill(_("Repo-exclude : "),
-                                                   ", ".join(repo.exclude))]
+                if repo.exclude:
+                    out += [base.fmtKeyValFill(_("Repo-exclude : "),
+                                               ", ".join(repo.exclude))]
 
-                    if repo.includepkgs:
-                        out += [base.fmtKeyValFill(_("Repo-include : "),
-                                                   ", ".join(repo.includepkgs))]
+                if repo.includepkgs:
+                    out += [base.fmtKeyValFill(_("Repo-include : "),
+                                               ", ".join(repo.includepkgs))]
 
-                    if ui_excludes_num:
-                        out += [base.fmtKeyValFill(_("Repo-excluded: "),
-                                                   ui_excludes_num)]
+                if ui_excludes_num:
+                    out += [base.fmtKeyValFill(_("Repo-excluded: "),
+                                               ui_excludes_num)]
 
-                    if repo.repofile:
-                        out += [base.fmtKeyValFill(_("Repo-filename: "),
-                                                   repo.repofile)]
+                if repo.repofile:
+                    out += [base.fmtKeyValFill(_("Repo-filename: "),
+                                               repo.repofile)]
 
-                    base.verbose_logger.log(logginglevels.DEBUG_3,
-                                            "%s\n",
-                                            "\n".join(map(misc.to_unicode, out)))
+                base.verbose_logger.info("%s\n",
+                                        "\n".join(map(misc.to_unicode, out)))
 
         if not verbose and cols:
             #  Work out the first (id) and last (enabled/disalbed/count),
